import numarray.records as rec
import windowPico

#Just add a new entry in picoId and windowName to add a pico motor control
#Modify any entry to take into account new parameters: IP, driver, motor, axis...
#50000steps about 2-3/4 turns

picoId = rec.array([('doublet', 'X',            '192.168.3.132', 'mircpico1', 'a2', 0),\
		    ('doublet', 'Y',            '192.168.3.132', 'mircpico1', 'a2', 1),\
		    ('doublet', 'Z',            '192.168.3.132', 'mircpico1', 'a1', 0),\
		   ('cyl lens',	'Z',	        '192.168.3.132', 'mircpico1', 'a1', 2),\
		   ('cyl lens',	'TILT',	        '192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('aperture array', 'tilt', 	'192.168.3.132', 'mircpico1', 'a1', 1),\
		   ('V-groove',	'X',            '192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('V-groove',	'TILT', 	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('lenslet', 'TILT',       	'192.168.3.132', 'mircpico1', 'a1', 2),\
		   ('spherical mirror', 'X',    '192.168.3.132', 'mircpico1', 'a1', 2),\
		   ('spherical mirror', 'Y',    '192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 1', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 1', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 2', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 2', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 3', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 3', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 4', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 4', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 5', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 5', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 6', 'X',     	'192.168.3.132', 'mircpico1', 'a1', 2),\
                   ('pick-off 6', 'Y',     	'192.168.3.132', 'mircpico1', 'a1', 2)],\
                   names='picoId, axis, IP, hostname, driver, motor')

windowName = ['doublet', 'cyl lens', 'aperture array', 'V-groove', 'lenslet', \
	      'spherical mirror', \
	      'pick-off 1', 'pick-off 2', 'pick-off 3', 'pick-off 4', 'pick-off 5', \
	      'pick-off 6']
	     
 		   
#format: pico motor's name, axis, IP, hostname, driver, motor
#how to query picoId:

#query field X
#print picoId.field('picoId')
# CharArray(['Z doublet', 'tilt cyl lens', 'Z cyl lens',
#            'tilt aperture array', 'tilt V-groove', 'X V-groove',
#            'tilt V-groove', 'tilt lenslet', 'X spherical mirror',
#            'Y spherical mirror', 'X pick-off 1', 'Y pick-off 1',
#            'X pick-off 2', 'Y pick-off 2', 'X pick-off 3',
#            'Y pick-off 3', 'X pick-off 4', 'Y pick-off 4',
#            'X pick-off 5', 'Y pick-off 5', 'X pick-off 6',
#            'Y pick-off 6'])
#

#query item X
#print picoId[0]
#('Z doublet', '192.168.3.132', 'mircpico1', 'a1', 2)

#query field X for item Y
#print picoId.field('picoId')[0]
#'Z doublet'

#query the item index whose field X is Y
#a, = picoId.field('picoId').search('Z cyl lens')[0]
#print a
#2

#query field X for the item whose field Y is Z
#print picoId.field('motor')[picoId.field('picoId').search('Z cyl lens')[0]][0]
#2 
# item whose field "recField" is "value"
def getIndex(rec, recField, value):
	index, = rec.field(recField).search(value)[0]
	return index

# field "field1" for the item whose field "field2" is "value"
def getFieldValue(rec, recField1, recField2, value):
	res = rec.field(recField1)[rec.field(recField2).search(value)[0]][0]
	return res 
